import java.awt.*;
import java.awt.image.*;
import java.util.*;

/**
 * ̓NX.
 */
public class Submarine implements Runnable, InternalObject, ActiveObject{
	private static int LEFT = 0; // 
	private static int RIGHT = 1; // E
	
	// ͂̍̍W
	private int x = 0;
	private int y = 0;
	
	// ͂̕ƍ
	private int width = 0;
	private int height = 0;
	
	// ͂̌
	private int direction = LEFT;
	
	private Image image; // ͂̕`C[W
	private BufferedImage oppositeImage; // ͂̉E̕`C[W
	
	private ImageObserver imageObserver;
	
	private InternalObjectContainer parent;
	
	private Thread thread;
	
	/**
	 * ͂쐬.
	 *
	 * @param parent ̐͂܂ރAvbg
	 * @param imageLoader C[W̃[hsIuWFNg
	 * @param imageObserver C[WɊւʒm󂯎IuWFNg
	 */
	public Submarine(InternalObjectContainer parent,
						ImageLoader imageLoader,
						ImageObserver imageObserver){
		this.parent = parent;
		
		// ͂̕`C[W[h
		image = imageLoader.loadImage("submarine.gif");
		
		this.imageObserver = imageObserver;
		
		width = image.getWidth(imageObserver);
		height = image.getHeight(imageObserver);
		
		// ͂̉E̕`C[W쐬
		oppositeImage = new BufferedImage(
			width, height, BufferedImage.TYPE_INT_ARGB
		);
		
		// ͂̉ẼC[Wɕ`悷OtBbNXReLXg쐬
		Graphics g = oppositeImage.createGraphics();
		
		// ͂̉ẼC[W`悷
		g.drawImage(image, width, 0, 0, height, 0, 0, width, height, imageObserver);
	}
	
	/**
	 * ͂̈ړJn.
	 */
	public void activate(){
		// ͂̈ړsXbh쐬AJn
		thread = new Thread(this);
		thread.start();
	}
	
	/**
	 * ͂̈ړs.
	 */
	public void run(){
		while(true){
			try{
				Thread.sleep(100);
			}catch(InterruptedException e){
			}
			
			if(direction == LEFT){
				x--; // Ɉړ
				
				// ʂ̍[Ƃ
				if(x < (-1 * getWidth())){
					Random random = new Random();
					
					// ͂yW_ȈʒuɈړ
					y = (int)((random.nextDouble() + 0.07) * 7);
					y = y * (parent.getHeight() / 8);
					
					boolean b = random.nextBoolean();
					
					if(b){
						// EɂȂ
						direction = RIGHT;
					}else{
						// ʂ̉E[Ɉړ
						x = parent.getWidth();
					}
				}
			}else{
				x++; // EɈړ
				
				// ʂ̉E[Ƃ
				if(x > parent.getWidth()){
					Random random = new Random();
					
					// ͂yW_ȈʒuɈړ
					y = (int)((random.nextDouble() + 0.07) * 7);
					y = y * (parent.getHeight() / 8);
					
					boolean b = random.nextBoolean();
					
					if(b){
						// ɂȂ
						direction = LEFT;
					}else{
						// ʂ̍[Ɉړ
						x = -1 * getWidth();
					}
				}
			}
		}
	}
	
	/**
	 * ͂̍xWԂ.
	 *
	 * @return ͂̍xW
	 */
	public int getX(){
		return x;
	}
	
	/**
	 * ͂̍yWԂ.
	 *
	 * @return ͂̍yW
	 */
	public int getY(){
		return y;
	}
	
	/**
	 * ͂̈ʒuݒ肷.
	 *
	 * @param x ͂̍xW
	 * @param y ͂̍yW
	 */
	public void setLocation(int x, int y){
		this.x = x;
		this.y = y;
	}
	
	/**
	 * ͂̕Ԃ.
	 *
	 * @return ͂̕
	 */
	public int getWidth(){
		return width;
	}
	
	/**
	 * ͂̍Ԃ.
	 *
	 * @return ͂̍
	 */
	public int getHeight(){
		return height;
	}
	
	/**
	 * ͂̕`C[WԂ.
	 *
	 * @return ͂̕`C[W
	 */
	public Image getImage(){
		if(direction == LEFT){
			return image;
		}else{
			return oppositeImage;
		}
	}
}